--	
--	####################################################################
--	SZABO'S PERSISTANCE MOD
--	0.0.0.07b	NOTE: 'b' stands for BETA VERSION! Use at your own risk!!!
--	####################################################################
--
-- CONFIGURE THE KEYS BELOW. Further down you find a list of the codes
local savekey = 96
local reloadkey = 110
local disablemodkey = 109
local modenabled = true -- SET TO false if you don't want the persistence to be enabled by default - does not affect saved
						--vehicles, this only applies to the 'persistent' ones you drove, which can cause problems in missions

-- CONFIGURE THE PATH WHERE THE FILE WILL BE SAVED. NOTE: Make sure Windows allows writing there.
-- 99.9% of the problems will be due bad data on the line below OR Windows permissions nonsense.
--	IMPORTANT!: Double-check the slashes (they're NOT backslashes) and the LAST SLASH too!
local savepath = "C:/Users/Alan/Documents/Rockstar Games/" --Use these: / (slash) and NOT THESE: \ (backslash)

-- CHOOSE A COOL TEXT TO APPEAR IN THE LICENSE PLATES OF YOUR SAVED VEHICLES! (Max. 8 dig.)
local platetext = "REGEX"
local useplates = true --change to false if you don't want the plates to change

--	####################################################################
--		KEY CODES
--	####################################################################
--
--	Space = 32            D4 = 52       O = 79             NumPad4 = 100         F9 = 120
--  PageUp = 33           D5 = 53       P = 80             NumPad5 = 101         F10 = 121
--	Next = 34             D6 = 54       Q = 81             NumPad6 = 102         F11 = 122
--  End = 35              D7 = 55       R = 82             NumPad7 = 103         F12 = 123
--	Home = 36             D8 = 56       S = 83             NumPad8 = 104         F13 = 124
--  Left = 37             D9 = 57       T = 84             NumPad9 = 105         F14 = 125
--	Up = 38               A = 65        U = 85             Multiply = 106        F15 = 126
--  Right = 39            B = 66        V = 86             Add = 107             F16 = 127
--	Down = 40             C = 67        W = 87             Separator = 108       F17 = 128
--  Select = 41           D = 68        X = 88             Subtract = 109        F18 = 129
--  Print = 42            E = 69        Y = 89             Decimal = 110         F19 = 130
--	Execute = 43          F = 70        Z = 90             Divide = 111          F20 = 131
--  PrintScreen = 44      G = 71        LWin = 91          F1 = 112              F21 = 132
--	Insert = 45           H = 72        RWin = 92          F2 = 113              F22 = 133
--  Delete = 46           I = 73        Apps = 93          F3 = 114              F23 = 134
--	Help = 47             J = 74        Sleep = 95         F4 = 115              F24 = 135
--  D0 = 48               K = 75        NumPad0 = 96       F5 = 116            
--	D1 = 49               L = 76        NumPad1 = 97       F6 = 117            
--  D2 = 50               M = 77        NumPad2 = 98       F7 = 118            
--	D3 = 51               N = 78        NumPad3 = 99       F8 = 119            
--
--	####################################################################
--		ABOUT THE MOD
--	####################################################################
--
--	What this mod does: It makes the last vehicles you've entered never disappear AND it allows you
--	to save as many vehicles as you want on the map, so they always stay there no matter what.
--	This allows you to effectively create 'garages' anywhere.
--
--	How to save vehicles: 
--	When driving a vehicle, park it and press the 'savekey', the plate will change to your user name, meaning that
--	the vehicle will be saved AT THE POSITION IT WAS WHEN YOU PRESSED THE KEY. The dot of the vehicle will change
-- 	from ORANGE (meaning it was one of the 3 'persistent' vehicles), to GREEN, meaning it is a SAVED vehicle.
--	Saved vehicles will never despawn, and you can revert all the saved vehicles to their saved positions by pressing
--	the 'reloadkey'. 
--	If you want to 'unsave' a vehicle, simply press the 'savekey' again when driving it, the plate will change to
--	NOTSAVED and the vehicle will despawn as soon as the engine sees fit.
--
--	####################################################################
--
-- ADVANCED CONFIGURATION (Don't change this if unsure):

local persistentqty = 3 	--number of cars to never despawn, both from saveds and random
local spawndistance = 70	-- distance the vehicles will appear
local loopspeed = 5			-- increase ONLY if vehicles are taking too long to appear

--	####################################################################
--
--	Copyright (c) 2015 Szabo on http://gtaforums.com
--
--	This file is licensed under a restrictive authorial license that can be enforced in most countries.
--	You need my permission to redistribute this file or to modify it (except for personal usage).
--	The non-compliance of the terms above will result in legal proceedings.
--	Thieves will be sued. Trespassers will be shot. Beware of the dog.
--
--	By using this you agree that I take ABSOLUTELY NO responsibility for the usage of this mod.
--	If it causes your roomba to go terminator and nuke our planet, it's your responsibility.
--
--	####################################################################
--	WARNING: THE LINES BELOW CONTAIN DEVELOPMENT DATA (IT'S MESSY)
--	####################################################################
--	
-- NOTES:
-- KNOWN ISSUES AND DEV NOTES: Neon lights, -Plate style- , -Tire smoke colour- , Wheel colours won't be saved
--	Xenon headlamps bugged (not working properly, idkw) VEHICLE.TOGGLE_VEHICLE_MOD(v, 22, x) is correct though
-- Plate styles: VEHICLE::GET_VEHICLE_PLATE_TYPE (not sure how to set)
--	
--	
--	####################################################################
--	
--	
--	Dirt level: VEHICLE::GET_VEHICLE_DIRT_LEVEL (& SET)
--
--	OTHER INFOS TO SAVE: 

-- no idea
-- VEHICLE::GET_IS_VEHICLE_PRIMARY_COLOUR_CUSTOM
-- VEHICLE::GET_VEHICLE_CUSTOM_PRIMARY_COLOUR
-- VEHICLE::SET_VEHICLE_CUSTOM_PRIMARY_COLOUR
-- VEHICLE::CLEAR_VEHICLE_CUSTOM_PRIMARY_COLOUR
-- (all of the above have PRIMARY and SECONDARY

-- bulletproof tyres
-- VEHICLE::GET_VEHICLE_TYRES_CAN_BURST
-- VEHICLE::SET_VEHICLE_TYRES_CAN_BURST

-- dirt lvl
-- GET_VEHICLE_DIRT_LEVEL(Vehicle vehicle) // 0xFD15C065
-- SET_VEHICLE_DIRT_LEVEL(Vehicle Vehicle, float DirtLVL) // 0x2B39128B

-- no idea
-- SET_VEHICLE_COLOUR_COMBINATION(Any p0, Any p1) // 0xA557AEAD
-- GET_VEHICLE_COLOUR_COMBINATION(Any p0) // 0x77AC1B4C
-- SET_VEHICLE_EXTRA_COLOURS(Any p0, Any p1, Any p2) // 0x515DB2A0
-- GET_VEHICLE_EXTRA_COLOURS(Any p0, Any p1, Any p2) // 0x80E4659B
-- SET_VEHICLE_LIVERY(Vehicle vehicle, int LiveryIndex) // 0x7AD87059
-- GET_VEHICLE_LIVERY(Any p0) // 0xEC82A51D
-- SET_VEHICLE_MOD_COLOR_1(Vehicle vehicle, int r, int g, int b) // 0xCBE9A54D
-- SET_VEHICLE_MOD_COLOR_2(Any p0, Any p1, Any p2) // 0xC32613C2
-- GET_VEHICLE_MOD_COLOR_1(Any p0, Any p1, Any p2, Any p3) // 0xE625510A
-- GET_VEHICLE_MOD_COLOR_2(Any p0, Any p1, Any p2) // 0x9B76BB8E

-- tire smoke color
-- SET_VEHICLE_TYRE_SMOKE_COLOR(Vehicle vehicle, int r, int g, int b) // 0x3EDEC0DB
-- GET_VEHICLE_TYRE_SMOKE_COLOR(Vehicle vehicle, int R, int G, int B) // 0x75280015
-- AND/OR ?? toggle mod 20
--
--	####################################################################
--
--	
--	TODO: If VEHICLE::IS_VEHICLE_IN_GARAGE_AREA then don't save it
--	TODO: LOOP ALL VEHICLES AND IF THERE ARE PASSENGERS AND PLAYER IS NOT ONE OF THEM, ALLOW DESPAWN
--			^(Remove persistence of vehicle if it's being driven and player is not on it to prevent problems.)
--	TODO:	SAVE DIRT LEVEL JUST FOR FUN :P
--	TODO:	DISABLE SAVING STOLEN CARS (YOU FILTHY THIEVES >:( ... :P) UPDATE: VEHICLE.IS_VEHICLE_STOLEN always returns false :(
--	TODO:
--	TODO:	learn how to use lua properly
--	TODO:	a function to deal with the repetitive loops
--	
--	
--



local szabopersist = {}

local unvid = 0

local lastPlayerState = false
local persistentVehicles = {}
local savedVehicles = {}
local spawnedSavedVehicles = {}
local drivenSavedVehicles = {}

function booltoint(bool)
	if bool then
		return 1
	else
		return 0
	end
end

function inttobool(int)
	if (int == 0) then
		return false
	else
		return true
	end
end

function file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f) return true else return false end
end

function getdictlen(d)
	local c = 0
	for x in pairs(d) do
		c = c + 1 -- C++ :B
	end
	return c
end

function szabopersist.unload()

	unloadspawnedsavedcars()
	disablepersistent()
	
end

function disablepersistent()
	for i, v in ipairs(persistentVehicles) do
		ENTITY.SET_ENTITY_AS_NO_LONGER_NEEDED(v)
		UI.REMOVE_BLIP(UI.GET_BLIP_FROM_ENTITY(v))
	end
	
	persistentVehicles = {}
end

function szabopersist.init()
	loadsaveddata()
end

function addvehicletosavedarray(v)
	
	coords = ENTITY.GET_ENTITY_COORDS(v, true)
	
	colr, colg, colb = VEHICLE.GET_VEHICLE_CUSTOM_PRIMARY_COLOUR(v,0,0,0)
	col2r, col2g, col2b = VEHICLE.GET_VEHICLE_CUSTOM_SECONDARY_COLOUR(v,0,0,0)

	vals = {ENTITY.GET_ENTITY_MODEL(v), coords.x, coords.y, coords.z, ENTITY.GET_ENTITY_HEADING(v), colr, colg, colb, col2r, col2g, col2b}

	table.insert(	vals,	VEHICLE.GET_VEHICLE_WHEEL_TYPE(v)  	 	)	--Wheels
	table.insert(	vals,	VEHICLE.GET_VEHICLE_WINDOW_TINT(v) 	 	)	--Film
					
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 0)   	 	)	--Spoilers
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 1)   	 	)	--Front Bumper
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 2)   	 	)	--Rear Bumper
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 3)   	 	)	--Side Skirt
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 4)   	 	)	--Exhaust
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 5)   	 	)	--Frame
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 6)   	 	)	--Grille
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 7)   	 	)	--Hood
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 8)   	 	)	--Fender
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 9)   	 	)	--Right Fender
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 10)  	 	)	--Roof
	
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 11)  	 	)	--Engine
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 12)  	 	)	--Brakes
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 13)  	 	)	--Transmission
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 14) 	 		)	--Horns
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 15)  	 	)	--Suspension
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 16)  	 	)	--Armor
				 
	table.insert(	vals,	VEHICLE.IS_TOGGLE_MOD_ON(v, 18)			)	--Turbo
	table.insert(	vals,	VEHICLE.IS_TOGGLE_MOD_ON(v, 22)			)	--Xenon
				 
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 23)	  		)	--Front Wheels
	table.insert(	vals,	VEHICLE.GET_VEHICLE_MOD(v, 24)	  		)	--Back Wheels (BIKES ONLY)

	unvid = unvid+1
	table.insert(savedVehicles, {unvid, vals})
	table.insert(drivenSavedVehicles, {unvid, v})
	
	ENTITY.SET_ENTITY_AS_MISSION_ENTITY(v, true, true)
	
	setvehiclemarker(v, 1)
	cleardriven()
	
	if (useplates and mtype == nil) then
		VEHICLE.SET_VEHICLE_NUMBER_PLATE_TEXT(v, string.sub(platetext, 1, 8));
	end
	
	showtext("THIS CAR WAS SAVED AT THIS POSITION")
	
end

function setvehiclemarker(v, mtype)

	blink = false
	if(mtype == 1) then
		--col = 2013200639 --green-yellow		driven
		col = 16742399 --green-blue
		blink = true
	elseif (mtype == 2) then
		--col = 4294902015 --yellow	persist
		col = 0xFF9900FF --orange	persist
		
	else
		col = 16742399 --green-blue		spawned
	end

	if (useplates and mtype == nil) then
		VEHICLE.SET_VEHICLE_NUMBER_PLATE_TEXT(v, string.sub(platetext, 1, 8));
	end
	
	removevehiclemarker(v)
	
	blip = UI.ADD_BLIP_FOR_ENTITY(v)
	UI.SET_BLIP_SCALE(blip, 0.6)
	UI.SET_BLIP_COLOUR(blip, col)
	
	if (blink) then
		UI.SET_BLIP_FLASHES(blip, true)
	end
	
end

function removevehiclemarker(v)
	while (UI.GET_BLIP_FROM_ENTITY(v) ~= 0) do
		UI.REMOVE_BLIP(UI.GET_BLIP_FROM_ENTITY(v))
		wait(0)
	end
end

function getcsvfromarrayentry(e)

	local valscsv = e[1]
		
	for i, val in ipairs(e) do
		if (i>1) then
			if (type(val) == type(true)) then
				valscsv = valscsv .. "," .. booltoint(val)
			else
				valscsv = valscsv .. "," .. val
			end
		end
	end
	
	return valscsv
end

function loadsaveddata()
	
	sfile = savepath .. "szabopersist"
	
	if (not file_exists(sfile)) then
		io.close(io.open(sfile, "w"))
	end
	
	for line in io.lines(sfile) do
		getarrayentryfromstringdata(line)
		unvid=unvid+1
	end
	
end

function getarrayentryfromstringdata(csvstr)
	vals = {}
	for val in string.gmatch(csvstr, '[^,]+') do
		table.insert(vals, val)
	end
	table.insert(savedVehicles, {unvid, vals})
	print(#savedVehicles)
end

function spawnvehiclefromdata(vals)
		
		enthash = vals[1]
		
		STREAMING.REQUEST_MODEL(enthash)
		
		while (not STREAMING.HAS_MODEL_LOADED(enthash)) do
			wait(0)
		end
		
		nearv = VEHICLE.GET_CLOSEST_VEHICLE(vals[2],vals[3],vals[4], 3, 0, 70)
		print(nearv)
		if (nearv ~= 0 and not isvehiclespawnedordriven(nearv)) then
			print('delete')
			ENTITY.SET_ENTITY_AS_MISSION_ENTITY(nearv, true, true)
			VEHICLE.DELETE_VEHICLE(nearv)
		end
		
		v = VEHICLE.CREATE_VEHICLE(enthash, vals[2],vals[3],vals[4], vals[5], true, true)
		VEHICLE.SET_VEHICLE_ON_GROUND_PROPERLY(v);
		
		--cloning vehicle
		
		VEHICLE.SET_VEHICLE_CUSTOM_PRIMARY_COLOUR(v,vals[6],vals[7],vals[8])
		VEHICLE.SET_VEHICLE_CUSTOM_SECONDARY_COLOUR(v,vals[9],vals[10],vals[11])
		
		-- VEHICLE.SET_VEHICLE_LIVERY(v, VEHICLE.GET_VEHICLE_LIVERY(currentVehicle))

		VEHICLE.SET_VEHICLE_MOD_KIT(v, 0);
		
		VEHICLE.SET_VEHICLE_WHEEL_TYPE(v, 			vals[12]);   		--Wheels
		VEHICLE.SET_VEHICLE_WINDOW_TINT(v, 			vals[13]);  		--Film
		VEHICLE.SET_VEHICLE_MOD(v, 0,  				vals[14], false);   --Spoilers
		VEHICLE.SET_VEHICLE_MOD(v, 1,  				vals[15], false);   --Front Bumper
		VEHICLE.SET_VEHICLE_MOD(v, 2,  				vals[16], false);   --Rear Bumper
		VEHICLE.SET_VEHICLE_MOD(v, 3,  				vals[17], false);   --Side Skirt
		VEHICLE.SET_VEHICLE_MOD(v, 4,  				vals[18], false);   --Exhaust
		VEHICLE.SET_VEHICLE_MOD(v, 5,  				vals[19], false);   --Frame
		VEHICLE.SET_VEHICLE_MOD(v, 6,  				vals[20], false);   --Grille
		VEHICLE.SET_VEHICLE_MOD(v, 7,  				vals[21], false);   --Hood
		VEHICLE.SET_VEHICLE_MOD(v, 8,  				vals[22], false);   --Fender
		VEHICLE.SET_VEHICLE_MOD(v, 9,  				vals[23], false);   --Right Fender
		VEHICLE.SET_VEHICLE_MOD(v, 10,  			vals[24], false);   --Roof
		VEHICLE.SET_VEHICLE_MOD(v, 11,  			vals[27], false);   --Engine
		VEHICLE.SET_VEHICLE_MOD(v, 12,  			vals[26], false);   --Brakes
		VEHICLE.SET_VEHICLE_MOD(v, 13,  			vals[30], false);   --Transmission
		VEHICLE.SET_VEHICLE_MOD(v, 14,  			vals[28], false);  	--Horns
		VEHICLE.SET_VEHICLE_MOD(v, 15,  			vals[29], false);   --Suspension
		VEHICLE.SET_VEHICLE_MOD(v, 16,  			vals[25], false);   --Armor
		VEHICLE.TOGGLE_VEHICLE_MOD(v, 18, inttobool(vals[31]));			--Turbo
		VEHICLE.TOGGLE_VEHICLE_MOD(v, 22, inttobool(vals[32]));			--Xenon
		VEHICLE.SET_VEHICLE_MOD(v, 23, 				vals[33], true); 	--Front Wheels
		VEHICLE.SET_VEHICLE_MOD(v, 24, 				vals[34], true);  	--Back Wheels (BIKE ONLY)
		

		
		--end cloning dolly
		
		STREAMING.SET_MODEL_AS_NO_LONGER_NEEDED(enthash)
		ENTITY.SET_ENTITY_AS_MISSION_ENTITY(v, true, true)
		-- 

		setvehiclemarker(v)
		
		return v
	
end

function unloadspawnedsavedcars()
	for k, v in pairs(spawnedSavedVehicles) do
		VEHICLE.DELETE_VEHICLE(v[2])
	end
	for i, dd in ipairs(drivenSavedVehicles) do
		ENTITY.SET_ENTITY_AS_MISSION_ENTITY(dd[2], true, true)
		VEHICLE.SET_VEHICLE_CUSTOM_PRIMARY_COLOUR(dd[2],255,0,255)
		VEHICLE.DELETE_VEHICLE(dd[2])
	end
	
	spawnedSavedVehicles = {}
	drivenSavedVehicles = {}
end

-- woof! woof! ... grrrrr WOOF!

local texttimer = 50 --this var is used for heatup too
local texttoshow = ""
function showtext(str)
	texttimer = 50
	texttoshow = str
end

function drawtext(str)
	UI.SET_TEXT_FONT(0)
	UI.SET_TEXT_SCALE(0.6, 0.8)
	UI.SET_TEXT_COLOUR(255, 255, 255, 255)
	UI.SET_TEXT_WRAP(0, 1)
	UI.SET_TEXT_CENTRE(true)
	UI.SET_TEXT_DROPSHADOW(15, 15, 0, 0, 0)
	UI.SET_TEXT_EDGE(5, 0, 0, 0, 255)
	UI._SET_TEXT_ENTRY("STRING")
	UI._ADD_TEXT_COMPONENT_STRING(texttoshow)
	UI._DRAW_TEXT(0.5, 0)
	texttimer = texttimer-1
end

local lastkeystate = false
local lastreloadkeystate = false
local lastdisablekeystate = false

local lazycounter = 0;
function lazyload(pped)

	if(lazycounter >= #savedVehicles) then	
		lazycounter = 0
	end
	lazycounter = lazycounter+1

	local vid = savedVehicles[lazycounter][1]	
	local vdata = savedVehicles[lazycounter][2]	
	
	playerCoords = ENTITY.GET_ENTITY_COORDS(pped, true)
	
	spawned = false
	for _, spawneddata in ipairs(spawnedSavedVehicles) do	
		if (vid == spawneddata[1]) then						
			spawned = true									
			break
		end
	end
	
	driven = false
	for _, drivendata in ipairs(drivenSavedVehicles) do		
		if (vid == drivendata[1]) then						
			driven = true									
			break
		end
	end
	
	if (GAMEPLAY.GET_DISTANCE_BETWEEN_COORDS(playerCoords.x, playerCoords.y, playerCoords.z, vdata[2], vdata[3], vdata[4], true	) < spawndistance) then
		if (not spawned and not driven) then	
			spv = spawnvehiclefromdata(vdata)	
			table.insert(spawnedSavedVehicles, {vid, spv})				
			print('vehicle near')
		end
	else
		if (spawned and not driven) then		
			local spawnedindex = getindexofvidinarray(vid,spawnedSavedVehicles)
			VEHICLE.DELETE_VEHICLE(spawnedSavedVehicles[spawnedindex][2])	
			table.remove(spawnedSavedVehicles, spawnedindex)		
			print('vehicle far')
		end
	end
end

function getindexofvidinarray(vid, array)
	for i, vdata in ipairs(array) do
		if(vid == vdata[1]) then
			return i
		end
	end
	return -1
end

function isvehiclespawnedordriven(v)
	for _, spawneddata in ipairs(spawnedSavedVehicles) do	
		if (v == spawneddata[2]) then						
			return true
		end
	end
	for _, drivendata in ipairs(drivenSavedVehicles) do		
		if (v == drivendata[2]) then						
			return true
		end
	end
end

function cleardriven()
	if (#drivenSavedVehicles > persistentqty) then						
		print('resetting old saved vehicle to its position')			
		local oldvehicle = drivenSavedVehicles[1][2]
		ENTITY.SET_ENTITY_AS_MISSION_ENTITY(oldvehicle, true, true)
		VEHICLE.DELETE_VEHICLE(oldvehicle)								
		table.remove(drivenSavedVehicles, 1)							
	end
end

hot = false;
function szabopersist.tick()

	local playerPed = PLAYER.PLAYER_PED_ID()
	local playerState = PED.IS_PED_IN_ANY_VEHICLE(playerPed, false)
	
	if(not hot) then
		print('heating up', texttimer)
		
		if (texttimer > 1) then
			if (not CAM.IS_SCREEN_FADED_OUT()) then
				texttimer = texttimer-2
			end
			return 0
		else
			hot = true
		end
		
	end
	
	local loadpass = 0
	while loadpass < loopspeed and #savedVehicles > 0 do
		lazyload(playerPed)
		loadpass = loadpass + 1
	end
	
	if(get_key_pressed(savekey) and not lastkeystate) then					
		
		local currentVehicle = PED.GET_VEHICLE_PED_IS_IN(playerPed, false)
		
		if (currentVehicle ~= 0) then										
			
			vehicleSaved = false											
														
			for i, dvd in ipairs(drivenSavedVehicles) do					
				if (dvd[2] == currentVehicle) then							
					vehicleSaved = true
					
					table.remove(savedVehicles, getindexofvidinarray(dvd[1], savedVehicles))	
					
					print("vehicle is saved, unsaving it")
					
					table.remove(drivenSavedVehicles, i)							
					
					ENTITY.SET_VEHICLE_AS_NO_LONGER_NEEDED(currentVehicle)			
					
					removevehiclemarker(currentVehicle)
					
					if (useplates) then
						VEHICLE.SET_VEHICLE_NUMBER_PLATE_TEXT(currentVehicle, "NOTSAVED");
					end
					
					showtext("THIS CAR WAS UNSAVED")
					
					break
					
				end
			end
			
			
			if (not vehicleSaved) then				
				
				for i, v in ipairs(persistentVehicles) do
					if (v == currentVehicle) then
						table.remove(persistentVehicles, i)
						print("turning persistent vehicle into saved vehicle")
						break
					end
				end
				
				print('saving vehicle')
				addvehicletosavedarray(currentVehicle)			
			end
			
			
			file = io.open(savepath .. "szabopersist", "w")		
			io.output(file)
			
			for i, v in ipairs(savedVehicles) do
				vdata = getcsvfromarrayentry(v[2])
				io.write(vdata .. "\n")
			end
			
			io.close(file)							
			
		
		end
		
	elseif(get_key_pressed(reloadkey) and not lastreloadkeystate) then
		unloadspawnedsavedcars()
		
	elseif(get_key_pressed(disablemodkey) and not lastdisablekeystate) then
		disablepersistent()
		modenabled = not modenabled
		
		if modenabled then
			showtext("Szabo's Persistance Mod ENABLED")
		else
			showtext("Szabo's Persistance Mod DISABLED")
		end
	end
	
	if (playerState and (not lastPlayerState)) then								
	
		local currentVehicle = PED.GET_VEHICLE_PED_IS_IN(playerPed, false)
		local vehiclePersistent = false
		
		print("entered vehicle")
		
		for i, svdata in ipairs(spawnedSavedVehicles) do						
			if (svdata[2] == currentVehicle) then								
				table.insert(drivenSavedVehicles, {svdata[1], currentVehicle})
				table.remove(spawnedSavedVehicles, i)							
				vehiclePersistent = true			
				setvehiclemarker(currentVehicle, 1)
				print("vehicle is saved, thus it's persistent, returning")
				cleardriven()
				break
			end
		end
		
		for i, svdata in ipairs(drivenSavedVehicles) do						
			if (svdata[2] == currentVehicle) then										
				vehiclePersistent = true
				print("vehicle is saved and in use, thus it's persistent, returning")
				break
			end
		end
		
		for _, v in ipairs(persistentVehicles) do
			if (v == currentVehicle) then
				vehiclePersistent = true
				print("vehicle already persistent, returning")
				break
			end
		end
		
		if (not vehiclePersistent and modenabled) then
			
			if (#persistentVehicles > persistentqty-1) then 
				removevehiclemarker(persistentVehicles[1])
				ENTITY.SET_ENTITY_AS_NO_LONGER_NEEDED(persistentVehicles[1])
				table.remove(persistentVehicles, 1)
				print("allowing old vehicle to despawn")
			end
			
			table.insert(persistentVehicles, currentVehicle)
			
			ENTITY.SET_ENTITY_AS_MISSION_ENTITY(currentVehicle, true, true)
			
			setvehiclemarker(currentVehicle, 2)
			
			print("current vehicle won't despawn")
		end
		

		
	end
	
	lastkeystate = get_key_pressed(savekey)
	lastreloadkeystate = get_key_pressed(reloadkey)
	lastdisablekeystate = get_key_pressed(disablemodkey)
	lastPlayerState = playerState;
	
	if (texttimer > 0) then
		drawtext(str)
	end
	
	-- szabopersist.debug()
	
end

-- function szabopersist.debug()

	-- local playerPed = PLAYER.PLAYER_PED_ID()
	-- local player = PLAYER.GET_PLAYER_PED(playerPed)
	-- local playerID = PLAYER.PLAYER_ID()
	-- local playerPos = ENTITY.GET_ENTITY_COORDS(playerPed, true)
	



	-- if(get_key_pressed(107)) then
		-- szabopersist.unload()
	
	-- testing
	-- VEHICLE.TOGGLE_VEHICLE_MOD(currentVehicle, 22, false)--xenon test
	-- VEHICLE.SET_VEHICLE_DIRT_LEVEL(currentVehicle, 15)
	
	-- if (VEHICLE.IS_VEHICLE_STOLEN(currentVehicle)) then
		-- showtext('vehicle is stolen')
	-- else
		-- showtext('vehicle is NOT stolen')
	-- end
	
	--end
	-- end testing

-- end

return szabopersist







